Leetcode - Game of Life

Screenshot from 2016-01-24 16:19:16.png

My code:

import java.util.HashSet;

public class Solution {
    public void gameOfLife(int[][] board) {
        if (board == null || board.length == 0 || board[0].length == 0)
            return;
        boolean[][] next = new boolean[board.length][board[0].length]; // false means dead and true means live
        /** traverse board to ensure whether life should be deal or live */
        for (int i = 0; i < board.length; i++) {
            for (int j = 0; j < board[0].length; j++) {
                simulate(i, j, board, next);
            }
        }
        
        /** update states for board depending on the nex[][] */
        for (int i = 0; i < board.length; i++) {
            for (int j = 0; j < board[0].length; j++) {
                if (next[i][j])
                    board[i][j] = 1;
                else
                    board[i][j] = 0;
            }
        }
    }
    
    /** simulate the next generation */
    private void simulate(int i, int j, int[][] board, boolean[][] next) {
        int liveNum = getLiveNumbers(i, j, board);
        if (board[i][j] == 1) { // if alive
            if (liveNum < 2 || liveNum > 3)
                next[i][j] = false;
            else
                next[i][j] = true;
        }
        else { // if dead
            if (liveNum == 3)
                next[i][j] = true;
        }
    }
    
    /** get the number of live animals around */
    private int getLiveNumbers(int i, int j, int[][] board) {
        int liveNum = 0;
        /** left side */
        if (j - 1 >= 0) {
            if (i - 1 >= 0) { // up
                if (board[i - 1][j - 1] == 1)
                    liveNum++;
            }
            if (board[i][j - 1] == 1)
                liveNum++;
            if (i + 1 < board.length) { // down
                if (board[i + 1][j - 1] == 1)
                    liveNum++;
            }
        }
        /** middle side */
        if (i - 1 >= 0) { // up
            if (board[i - 1][j] == 1)
                liveNum++;
        }
        if (i + 1 < board.length) { // down
            if (board[i + 1][j] == 1)
                liveNum++;
        }
        /** right side */
        if (j + 1 < board[0].length) {
            if (i - 1 >= 0) { // up
                if (board[i - 1][j + 1] == 1)
                    liveNum++;
            }
            if (board[i][j + 1] == 1)
                liveNum++;
            if (i + 1 < board.length) { // down
                if (board[i + 1][j + 1] == 1)
                    liveNum++;
            }
        }
        
        return liveNum;
    }
    
    public static void main(String[] args) {
        Solution test = new Solution();
        int[][] board = new int[1][2];
        board[0][0] = 1;
        board[0][1] = 1;
        test.gameOfLife(board);
    }
}

终于他妈过了测试。
这道题目和CS61B其中一次大作业很像。但是,这道题目简化了一些。
比如,(0, 0) 的邻居,就没有8个了。但是其实可以跳转到另外一端的。所以一开始我写的是一个更复杂的版本。在这个版本下,可以实现所谓的,无限大区域。因为他是球形的,无边界的。然后通过HashSet避免重复统计。

That Code:

import java.util.HashSet;

public class Solution {
    public void gameOfLife(int[][] board) {
        if (board == null || board.length == 0 || board[0].length == 0)
            return;
        boolean[][] next = new boolean[board.length][board[0].length]; // false means dead and true means live
        /** traverse board to ensure whether life should be deal or live */
        for (int i = 0; i < board.length; i++) {
            for (int j = 0; j < board[0].length; j++) {
                simulate(i, j, board, next);
            }
        }
        
        /** update states for board depending on the nex[][] */
        for (int i = 0; i < board.length; i++) {
            for (int j = 0; j < board[0].length; j++) {
                if (next[i][j])
                    board[i][j] = 1;
                else
                    board[i][j] = 0;
            }
        }
    }
    
    /** simulate the next generation */
    private void simulate(int i, int j, int[][] board, boolean[][] next) {
        int liveNum = getLiveNumbers(i, j, board);
        if (board[i][j] == 1) { // if alive
            if (liveNum < 2 || liveNum > 3)
                next[i][j] = false;
            else
                next[i][j] = true;
        }
        else { // if dead
            if (liveNum == 3)
                next[i][j] = true;
        }
    }
    
    /** get the number of live animals around */
    private int getLiveNumbers(int i, int j, int[][] board) {
        int liveNum = 0;
        HashSet<Integer> tracker = new HashSet<Integer>();
        /** left */
        int colLeft = (j - 1 >= 0) ? (j - 1) : (board[0].length - 1);
        int colRight = (j + 1 <= board[0].length - 1) ? (j + 1) : (0);
        int rowUp = (i - 1 >= 0) ? (i - 1) : (board.length - 1);
        int rowDown = (i + 1 <= board.length - 1) ? (i + 1) : (0);
        tracker.add(i * board[0].length + j); // add itself to avoid repeating
        /** update left side */
        if (!tracker.contains(rowUp * board[0].length + colLeft) && board[rowUp][colLeft] == 1) {
            liveNum++;
            tracker.add(rowUp * board[0].length + colLeft);   
        }
        if (!tracker.contains(i * board[0].length + colLeft) && board[i][colLeft] == 1) {
            liveNum++;
            tracker.add(i * board[0].length + colLeft);    
        }
        if (!tracker.contains(rowDown * board[0].length + colLeft) && board[rowDown][colLeft] == 1) {
            liveNum++;
            tracker.add(rowDown * board[0].length + colLeft);      
        }
        /** update middle side */
        if (!tracker.contains(rowUp * board[0].length + j) && board[rowUp][j] == 1) {
            liveNum++;
            tracker.add(rowUp * board[0].length + j);        
        }
        if (!tracker.contains(rowDown * board[0].length + j) && board[rowDown][j] == 1) {
            liveNum++;
            tracker.add(rowDown * board[0].length + j);  
        }
        /** update right side */
        if (!tracker.contains(rowUp * board[0].length + colRight) && board[rowUp][colRight] == 1) {
            liveNum++;
            tracker.add(rowUp * board[0].length + colRight);  
        }
        if (!tracker.contains(i * board[0].length + colRight) && board[i][colRight] == 1) {
            liveNum++;
            tracker.add(i * board[0].length + colRight);     
        }
        if (!tracker.contains(rowDown * board[0].length + colRight) && board[rowDown][colRight] == 1) {
            liveNum++;
            tracker.add(rowDown * board[0].length + colRight);  
        }
            
        return liveNum;
    }
    
    public static void main(String[] args) {
        Solution test = new Solution();
        int[][] board = new int[1][2];
        board[0][0] = 1;
        board[0][1] = 1;
        test.gameOfLife(board);
    }
}

这道题木没什么难的,就是有些烦,题目表述也不是很明确。

Anyway, Good luck, Richardo!

My code:

public class Solution {
    private int[][] directions = new int[][]{{1, -1}, {0, -1}, {-1, -1}, {-1, 0}, {1, 0}, {-1, 1}, {0, 1}, {1, 1}};
    public void gameOfLife(int[][] board) {
        if (board == null || board.length == 0 || board[0].length == 0) {
            return;
        }
        
        for (int i = 0; i < board.length; i++) {
            for (int j = 0; j < board[0].length; j++) {
                board[i][j] *= 10;
            }
        }
        
        for (int i = 0; i < board.length; i++) {
            for (int j = 0; j < board[0].length; j++) {
                simulate(board, i, j);
            }
        }
        
        for (int i = 0; i < board.length; i++) {
            for (int j = 0; j < board[0].length; j++) {
                board[i][j] %= 10;
            }
        }
    }
    
    private void simulate(int[][] board, int i, int j) {
        int live = 0;
        int dead = 0;
        for (int row = 0; row < directions.length; row++) {
            int tempI = i + directions[row][0];
            int tempJ = j + directions[row][1];
            if (tempI >= 0 && tempI < board.length && tempJ >= 0 && tempJ < board[0].length) {
                if (board[tempI][tempJ] / 10 == 1) {
                    live++;
                }
                else {
                    dead++;
                }
            }
        }
        
        if (board[i][j] / 10 == 1) {
            if (live < 2) {
                board[i][j] += 0;
            }
            else if (live < 4) {
                board[i][j] += 1;
            }
            else {
                board[i][j] += 0;
            }
        }
        else {
            if (live == 3) {
                board[i][j] += 1;
            } 
            else {
                board[i][j] += 0;
            }
        }
    }
}

这道题目之前一直在想如何in place
同学提醒,可以用int表示更多的信息。
一开始,所有board[i][j] * 10
所以,原状态全部保存在十位,
最新状态全部保存在个位。
然后就没问题了。

这次八个方向采用了 8*2的array
方便多了。。

Anyway, Good luck, Richardo! -- 09/05/2016

最后编辑于
©著作权归作者所有,转载或内容合作请联系作者
  • 序言:七十年代末,一起剥皮案震惊了整个滨河市,随后出现的几起案子,更是在滨河造成了极大的恐慌,老刑警刘岩,带你破解...
    沈念sama阅读 202,607评论 5 476
  • 序言:滨河连续发生了三起死亡事件,死亡现场离奇诡异,居然都是意外死亡,警方通过查阅死者的电脑和手机,发现死者居然都...
    沈念sama阅读 85,047评论 2 379
  • 文/潘晓璐 我一进店门,熙熙楼的掌柜王于贵愁眉苦脸地迎上来,“玉大人,你说我怎么就摊上这事。” “怎么了?”我有些...
    开封第一讲书人阅读 149,496评论 0 335
  • 文/不坏的土叔 我叫张陵,是天一观的道长。 经常有香客问我,道长,这世上最难降的妖魔是什么? 我笑而不...
    开封第一讲书人阅读 54,405评论 1 273
  • 正文 为了忘掉前任,我火速办了婚礼,结果婚礼上,老公的妹妹穿的比我还像新娘。我一直安慰自己,他们只是感情好,可当我...
    茶点故事阅读 63,400评论 5 364
  • 文/花漫 我一把揭开白布。 她就那样静静地躺着,像睡着了一般。 火红的嫁衣衬着肌肤如雪。 梳的纹丝不乱的头发上,一...
    开封第一讲书人阅读 48,479评论 1 281
  • 那天,我揣着相机与录音,去河边找鬼。 笑死,一个胖子当着我的面吹牛,可吹牛的内容都是我干的。 我是一名探鬼主播,决...
    沈念sama阅读 37,883评论 3 395
  • 文/苍兰香墨 我猛地睁开眼,长吁一口气:“原来是场噩梦啊……” “哼!你这毒妇竟也来了?” 一声冷哼从身侧响起,我...
    开封第一讲书人阅读 36,535评论 0 256
  • 序言:老挝万荣一对情侣失踪,失踪者是张志新(化名)和其女友刘颖,没想到半个月后,有当地人在树林里发现了一具尸体,经...
    沈念sama阅读 40,743评论 1 295
  • 正文 独居荒郊野岭守林人离奇死亡,尸身上长有42处带血的脓包…… 初始之章·张勋 以下内容为张勋视角 年9月15日...
    茶点故事阅读 35,544评论 2 319
  • 正文 我和宋清朗相恋三年,在试婚纱的时候发现自己被绿了。 大学时的朋友给我发了我未婚夫和他白月光在一起吃饭的照片。...
    茶点故事阅读 37,612评论 1 329
  • 序言:一个原本活蹦乱跳的男人离奇死亡,死状恐怖,灵堂内的尸体忽然破棺而出,到底是诈尸还是另有隐情,我是刑警宁泽,带...
    沈念sama阅读 33,309评论 4 318
  • 正文 年R本政府宣布,位于F岛的核电站,受9级特大地震影响,放射性物质发生泄漏。R本人自食恶果不足惜,却给世界环境...
    茶点故事阅读 38,881评论 3 306
  • 文/蒙蒙 一、第九天 我趴在偏房一处隐蔽的房顶上张望。 院中可真热闹,春花似锦、人声如沸。这庄子的主人今日做“春日...
    开封第一讲书人阅读 29,891评论 0 19
  • 文/苍兰香墨 我抬头看了看天上的太阳。三九已至,却和暖如春,着一层夹袄步出监牢的瞬间,已是汗流浃背。 一阵脚步声响...
    开封第一讲书人阅读 31,136评论 1 259
  • 我被黑心中介骗来泰国打工, 没想到刚下飞机就差点儿被人妖公主榨干…… 1. 我叫王不留,地道东北人。 一个月前我还...
    沈念sama阅读 42,783评论 2 349
  • 正文 我出身青楼,却偏偏与公主长得像,于是被迫代替她去往敌国和亲。 传闻我的和亲对象是个残疾皇子,可洞房花烛夜当晚...
    茶点故事阅读 42,316评论 2 342

推荐阅读更多精彩内容